#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Icon=img\prog.ico
#AutoIt3Wrapper_Outfile=PrintReminder.exe
#AutoIt3Wrapper_UseUpx=n
#AutoIt3Wrapper_Res_Fileversion=1.2.0.0
#AutoIt3Wrapper_Res_LegalCopyright=Oscar (www.autoit.de)
#AutoIt3Wrapper_Res_Language=1031
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
#include <ButtonConstants.au3>
#include <Constants.au3>
#include <Date.au3>
#include <EditConstants.au3>
#include <GUIConstantsEx.au3>
#include <WindowsConstants.au3>
#include 'PrintMG\printMGv2.au3'

Opt('TrayOnEventMode', 1)
Opt('TrayMenuMode', 1)

Global $sTitle = 'PrintReminder v1.2'
If Not @Compiled Then $sTitle &= ' / Script!'
Global $sVersion = '1.2.0.0'
Global $sDate = '14.06.2012'
Global $sPrinterSpoolDir = @WindowsDir & '\system32\spool\PRINTERS'

Global $sAppDir = @AppDataDir & '\PrintReminder\'
If Not FileExists($sAppDir) Then DirCreate($sAppDir)
Global $sInifile = $sAppDir & 'PrintReminder.ini'
Global $fAutostart = IniRead($sInifile, 'Config', 'Autostart', False) == True
Global $fSound = IniRead($sInifile, 'Config', 'Sound', False) == True
Global $iReminderTime = IniRead($sInifile, 'Config', 'ReminderTime', 7)
If $iReminderTime < 2 Or $iReminderTime > 28 Then $iReminderTime = 7
Global $iTime = IniRead($sInifile, 'Config', 'SoundTime', 2)
If $iTime < 0 Or $iTime > 2 Then $iTime = 2

TrayCreateItem($sTitle)
TrayItemSetState(-1, $TRAY_DISABLE)
TraySetIcon(@ScriptDir & '\img\prog.ico')
TrayCreateItem('')
$idTraySettings = TrayCreateItem('Einstellungen')
TrayItemSetOnEvent(-1, '_Settings')
$idTrayPrint = TrayCreateItem('Testseite drucken...')
TrayItemSetOnEvent(-1, '_PrintTestPage')
$idTrayHelp = TrayCreateItem('Hilfe')
TrayItemSetOnEvent(-1, '_Help')
TrayCreateItem('')
TrayCreateItem('Beenden')
TrayItemSetOnEvent(-1, '_End')
Global $iLastAccess = _LastPrinterAccess(), $iCheckAccess = $iLastAccess
TraySetToolTip(StringFormat('%s\nErinnert daran regelmig etwas auszudrucken.\n%s Tag(e) seit dem letzten Ausdruck.', $sTitle, $iLastAccess))
TraySetClick(8)
Global $iSoundTimer = TimerInit(), $aSoundTimer[3] = [60000*15, 60000*30, 60000*60]

While Sleep(5000)
	$iLastAccess = _LastPrinterAccess()
	If $iLastAccess <> $iCheckAccess Then
		$iCheckAccess = $iLastAccess
		TraySetToolTip(StringFormat('%s\nErinnert daran regelmig etwas auszudrucken.\n%s Tag(e) seit dem letzten Ausdruck.', $sTitle, $iLastAccess))
		If $iLastAccess > $iReminderTime Then
			TraySetState(4) ; Trayicon blinkt
			If $fSound Then
				$iSoundTimer = TimerInit()
				_PlayDefaultSystemSound('SystemExclamation', 0)
			EndIf
		Else
			TraySetState(8) ; Trayicon wieder normal
		EndIf
	EndIf
	If $fSound And $iLastAccess > $iReminderTime And TimerDiff($iSoundTimer) > $aSoundTimer[$iTime] Then
		$iSoundTimer = TimerInit()
		_PlayDefaultSystemSound('SystemExclamation', 0)
	EndIf
WEnd

Func _End()
	Exit
EndFunc

Func _LastPrinterAccess()
	Local $sLastModified = FileGetTime($sPrinterSpoolDir, 0, 1)
	If @error Then Return SetError(1, 0, 0)
	$sLastModified = StringRegExpReplace($sLastModified, '(\d{4})(\d{2})(\d{2})(\d{2})(\d{2})(\d{2})', '$1/$2/$3 $4:$5:$6')
	Return _DateDiff('D', $sLastModified, _NowCalc())
EndFunc

Func _Settings()
	TrayItemSetState($idTraySettings, $TRAY_UNCHECKED)
	Local $hSettingsGui, $idAutostart, $idReminderTime, $idSound, $idSoundTest, $aidTime[3], $idApply, $idCancel, $iTimer
	$hSettingsGui = GUICreate($sTitle & ' - Einstellungen', 400, 335, -1, -1, BitOR($WS_POPUPWINDOW, $WS_CAPTION))
	GUISetIcon(@ScriptDir & '\img\prog.ico')
	GUISetFont(9, 400, 0, 'Arial')
	GUISetBkColor(0xCCCCCC)
	GUICtrlCreateGroup('Autostart', 10, 10, 380, 52)
	$idAutostart = GUICtrlCreateCheckbox('Programm mit Windows starten', 25, 28, 260, 25)
	GUICtrlSetFont(-1, 10, 400, 0, 'Verdana')
	GUICtrlCreateGroup('', -99, -99, 1, 1)
	GUICtrlCreateGroup('Erinnerungszeit', 10, 80, 380, 62)
	$idReminderTime = GUICtrlCreateInput($iReminderTime, 25, 104, 54, 25, $ES_READONLY)
	GUICtrlSetFont(-1, 11, 400, 0, 'Verdana')
	GUICtrlCreateUpdown(-1)
	GUICtrlSetLimit(-1, 28, 2)
	GUICtrlCreateLabel('Tage nach dem letzten Ausdruck', 88, 108, 290, 25)
	GUICtrlSetFont(-1, 10, 400, 0, 'Verdana')
	GUICtrlCreateGroup('', -99, -99, 1, 1)
	GUICtrlCreateGroup('Soundeffekt', 10, 160, 380, 122)
	$idSound = GUICtrlCreateCheckbox('Sound einschalten', 25, 178, 240, 25)
	GUICtrlSetFont(-1, 10, 400, 0, 'Verdana')
	$idSoundTest = GUICtrlCreateButton('Test', 320, 178, 60, 22)
	GUICtrlSetTip(-1, 'Testet den Sound im 3-Sekunden-Rhythmus und lsst das Trayicon blinken.')
	$aidTime[0] = GUICtrlCreateRadio('viertelstndlich erinnern', 50, 210, 200, 20)
	GUICtrlSetFont(-1, 10, 400, 0, 'Verdana')
	$aidTime[1] = GUICtrlCreateRadio('halbstndlich erinnern', 50, 230, 200, 20)
	GUICtrlSetFont(-1, 10, 400, 0, 'Verdana')
	$aidTime[2] = GUICtrlCreateRadio('stndlich erinnern', 50, 250, 200, 20)
	GUICtrlSetFont(-1, 10, 400, 0, 'Verdana')
	GUICtrlCreateGroup('', -99, -99, 1, 1)
	$idApply = GUICtrlCreateButton('bernehmen', 180, 300, 100, 25, $BS_DEFPUSHBUTTON)
	GUICtrlSetFont(-1, 9, 400, 0, 'Arial')
	$idCancel = GUICtrlCreateButton('Abbrechen', 290, 300, 100, 25)
	GUICtrlSetFont(-1, 9, 400, 0, 'Arial')
	If $fAutostart Then GUICtrlSetState($idAutostart, $GUI_CHECKED)
	GUICtrlSetState($aidTime[$iTime], $GUI_CHECKED)
	If $fSound Then GUICtrlSetState($idSound, $GUI_CHECKED)
	GUISetState()
	While True
		Switch GUIGetMsg()
			Case $GUI_EVENT_CLOSE, $idCancel
				ExitLoop
			Case $idApply
				$fAutostart = BitAND(GUICtrlRead($idAutostart), $GUI_CHECKED) == $GUI_CHECKED
				IniWrite($sInifile, 'Config', 'Autostart', $fAutostart)
				If $fAutostart Then
					If @Compiled Then FileCreateShortcut(@ScriptFullPath, @StartupDir & '\' & @ScriptName)
				Else
					If @Compiled Then FileDelete(@StartupDir & '\' & @ScriptName & '.lnk')
				EndIf
				$iReminderTime = GUICtrlRead($idReminderTime)
				IniWrite($sInifile, 'Config', 'ReminderTime', $iReminderTime)
				$fSound = BitAND(GUICtrlRead($idSound), $GUI_CHECKED) == $GUI_CHECKED
				IniWrite($sInifile, 'Config', 'Sound', $fSound)
				For $i = 0 To 2
					If BitAND(GUICtrlRead($aidTime[$i]), $GUI_CHECKED) Then
						$iTime = $i
						IniWrite($sInifile, 'Config', 'SoundTime', $i)
						ExitLoop
					EndIf
				Next
				ExitLoop
			Case $idSoundTest
				GUICtrlSetData($idSoundTest, 'Stop')
				$iTimer = TimerInit()
				_PlayDefaultSystemSound('SystemExclamation', 0)
				TraySetState(4) ; Trayicon blinkt
				Do
					If TimerDiff($iTimer) > 3000 Then
						_PlayDefaultSystemSound('SystemExclamation', 0)
						$iTimer = TimerInit()
					EndIf
				Until GUIGetMsg() = $idSoundTest
				GUICtrlSetData($idSoundTest, 'Test')
				TraySetState(8) ; Trayicon wieder normal
		EndSwitch
	WEnd
	GUIDelete($hSettingsGui)
EndFunc

Func _PrintTestPage()
	TrayItemSetState($idTrayPrint, $TRAY_UNCHECKED)
	Local $hPrintGui, $idPrint, $idCancel
	$hPrintGui = GUICreate($sTitle & ' - Testseite drucken', 404, 580, -1, -1, BitOR($WS_POPUPWINDOW, $WS_CAPTION))
	GUISetIcon(@ScriptDir & '\img\prog.ico')
	GUICtrlCreatePic(@ScriptDir & '\img\CMYK-Test.jpg', 0, 0, 404, 580)
	GUICtrlSetState(-1, $GUI_DISABLE)
	$idPrint = GUICtrlCreateButton('Drucken...', 180, 550, 100, 25, $BS_DEFPUSHBUTTON)
	GUICtrlSetFont(-1, 9, 400, 0, 'Arial')
	$idCancel = GUICtrlCreateButton('Abbrechen', 290, 550, 100, 25)
	GUICtrlSetFont(-1, 9, 400, 0, 'Arial')
	GUISetState()
	While True
		Switch GUIGetMsg()
			Case $GUI_EVENT_CLOSE, $idCancel
				ExitLoop
			Case $idPrint
				_PrintTestImg()
				ExitLoop
		EndSwitch
	WEnd
	GUIDelete($hPrintGui)
EndFunc

Func _PrintTestImg()
	Local $hp, $mmssgg, $newselect, $pght, $pgwd, $xOffset, $yOffset
	Local $hp = _PrintDllStart($mmssgg, @ScriptDir & '\PrintMG\PrintMG.dll')
	If $hp = 0 Then Return SetError(1, 0, 0)
	$newselect = _PrintSetPrinter($hp)
	If $newselect = 0 Or @error Then
		_PrintAbort($hp)
		_printDllClose($hp)
		Return SetError(2, 0, 0)
	EndIf
	_PrintPageOrientation($hp, 1)
	_PrintSetDocTitle($hp, "CMYK-Test")
	_PrintStartPrint($hp)
	$yOffset = _PrintGetYOffset($hp)
	$xOffset = _PrintGetXOffset($hp)
	$pght = _PrintGetpageheight($hp) - $yOffset * 2
	$pgwd = _PrintGetpageWidth($hp) - $xOffset * 2
	_PrintImage($hp, @ScriptDir & "\img\CMYK-Test.jpg", $xOffset, $yOffset, $pgwd, $pght)
	_PrintEndPrint($hp)
	_PrintNewPage($hp)
	_printDllClose($hp)
EndFunc

Func _Help()
	TrayItemSetState($idTrayHelp, $TRAY_UNCHECKED)
	Local $hHelpGui, $sMsg, $iWidth = 590, $idClose, $idAuthor1, $idAuthor2, $idAuthor3, $sLink1, $sLink2, $sLink3
	$hHelpGui = GUICreate($sTitle & ' - Hilfe', $iWidth + 20, 520, -1, -1, BitOR($WS_POPUPWINDOW, $WS_CAPTION))
	GUISetIcon(@ScriptDir & '\img\prog.ico')
	GUISetBkColor(0xFFFFDD)
	$sMsg = 'Version:   %s\nDatum:    %s'
	GUICtrlCreateLabel(StringFormat($sMsg, $sVersion, $sDate), 80, 15, $iWidth, 40)
	GUICtrlSetFont(-1, 12, 600, 0, 'Verdana')
	GUICtrlCreateIcon(@ScriptDir & '\img\prog.ico', 3, 10, 5, 48, 48)
	$sMsg = 'Autor "PrintReminder": \tThomas Stephan'
	GUICtrlCreateLabel(StringFormat($sMsg), 10, 70, 320, 20)
	GUICtrlSetFont(-1, 10, 400, 0, 'Verdana')
	$sLink1 = 'mailto:oscar@elektronik-kurs.de'
	$idAuthor1 = GUICtrlCreateLabel($sLink1, 330, 70, 260, 20)
	GUICtrlSetFont(-1, 10, 400, 4, 'Verdana')
	GUICtrlSetColor(-1, 0x0000FF)
	GUICtrlSetCursor(-1, 0)
	$sMsg = 'Autor "PrintMG.au3": \tMartin Gibson "martin"'
	GUICtrlCreateLabel(StringFormat($sMsg), 10, 100, 320, 20)
	GUICtrlSetFont(-1, 10, 400, 0, 'Verdana')
	$sLink2 = 'http://www.autoitscript.com/forum/'
	$idAuthor2 = GUICtrlCreateLabel($sLink2, 330, 100, 260, 20)
	GUICtrlSetFont(-1, 10, 400, 4, 'Verdana')
	GUICtrlSetColor(-1, 0x0000FF)
	GUICtrlSetCursor(-1, 0)
	$sMsg = 'Autor des Icons: \tBenjamin Fleming'
	GUICtrlCreateLabel(StringFormat($sMsg), 10, 130, 300, 20)
	GUICtrlSetFont(-1, 10, 400, 0, 'Verdana')
	$sLink3 = 'http://mediadesign.deviantart.com/'
	$idAuthor3 = GUICtrlCreateLabel($sLink3, 330, 130, 260, 20)
	GUICtrlSetFont(-1, 10, 400, 4, 'Verdana')
	GUICtrlSetColor(-1, 0x0000FF)
	GUICtrlSetCursor(-1, 0)
	$sMsg = 'Rechtliches:'
	GUICtrlCreateLabel(StringFormat($sMsg), 10, 180, $iWidth, 20)
	GUICtrlSetFont(-1, 11, 800, 4, 'Verdana')
	$sMsg = '- Dieses Programm darf, zeitlich unbegrenzt, kostenlos genutzt werden!\n'
	$sMsg &= '- Eine evtl. Weitergabe muss kostenlos, vollstndig und unverndert erfolgen!\n'
	$sMsg &= '- nderungen am Programm drfen nur durch den Autor vorgenommen werden!\n\n'
	GUICtrlCreateLabel(StringFormat($sMsg), 10, 200, $iWidth, 80)
	GUICtrlSetFont(-1, 11, 400, 2, 'Verdana')
	$sMsg = 'Programmbeschreibung:'
	GUICtrlCreateLabel(StringFormat($sMsg), 10, 280, $iWidth, 20)
	GUICtrlSetFont(-1, 11, 800, 4, 'Verdana')
	$sMsg = 'Das Programm zhlt die Tage, an denen nichts gedruckt wurde. Wenn der Benutzer dann etwas ausdruckt, registriert das Programm den Ausdruck und setzt den internen Zhler wieder auf Null.\nWird sieben Tage lang nichts ausgedruckt, beginnt ab dem achten Tag das Tray-Icon zu blinken, um dem Benutzer darauf aufmerksam zu machen mal wieder etwas zu drucken.\nGerade bei Tintenstrahldruckern ist es ratsam, regelmig etwas auszudrucken, um ein eintrocknen des Druckkopfes zu verhindern. Dieser msste sonst aufwendig gereinigt oder im Extremfall sogar ausgetauscht werden.'
	GUICtrlCreateLabel(StringFormat($sMsg), 10, 300, $iWidth, 150)
	GUICtrlSetFont(-1, 10, 400, 2, 'Verdana')
	$idClose = GUICtrlCreateButton('Ok', Int($iWidth / 2) - 40, 480, 80, 25, $BS_DEFPUSHBUTTON)
	GUICtrlSetFont(-1, 10, 400, 0, 'Arial')
	GUISetState(@SW_SHOW, $hHelpGui)
	While True
		Switch GUIGetMsg()
			Case $GUI_EVENT_CLOSE, $idClose
				ExitLoop
			Case $idAuthor1
				ShellExecute($sLink1)
			Case $idAuthor2
				ShellExecute($sLink2)
			Case $idAuthor3
				ShellExecute($sLink3)
		EndSwitch
	WEnd
	GUIDelete($hHelpGui)
EndFunc

; #FUNCTION# ====================================================================================================================
; Name...........:    _PlayDefaultSystemSound()
; Description ...:    Spielt einen Systemklang, welcher in der Registry definiert ist.
; Syntax.........:    _PlayDefaultSystemSound($sSoundName, $iWait = 0)
; Parameters ....:    $sSoundName                - Name des SystemSound's
;                    | Default                   - Standardton Warnsignal / Default Beep
;                    | CriticalBatteryAlarm      - Alarm bei kritischem Batteriestand / when battery is critical
;                    | DeviceConnect            - Gerteanschlu / when a device is connect
;                    | DeviceDisconnect          - Gertetrennung / when a device is disconnect
;                    | DeviceFail                - Gerteanschlu fehlgeschlagen / when a deviceconnect is fail
;                    | LowBatteryAlarm           - Alarm bei niedrigem Batteriestand / when battery is low
;                    | MailBeep                  - Posteingangsbenachrichtigung / when email is received
;                    | SystemAsterisk            - Stern / Asterisk
;                    | SystemExclamation         - Hinweis / when windows shows a warning
;                    | SystemExit                - Windows beenden / when Windows shuts down
;                    | SystemHand                - Kritischer Abbruch / when a critical stop occurs
;                    | SystemNotification        - Sprechblase / when a critical stop occurs
;                    | SystemStart               - Windows starten / when Windows starts up
;                    | WindowsLogoff             - beim Windows abmelden / when logging off Windows
;                    | WindowsLogon              - beim Windows anmelden / when logging on Windows
;                    | EmptyRecycleBin           - Lschen des Papierkorbs / when recycle bin is emptied
;                    | Navigating                - Browser Klick / navigating in browser

;                     $iWait                     - Warten bis SoundPlay beendet? (0 = nein / 1 = ja)
; Return values .:    -----
; Author ........:    funkey (AutoIt.de)
; ===============================================================================================================================
Func _PlayDefaultSystemSound($sSoundName, $iWait = 0) ; funkey
    Local $sKey = 'HKEY_CURRENT_USER\AppEvents\Schemes\Apps\.Default'
    If $sSoundName = 'EmptyRecycleBin' Or $sSoundName = 'Navigating' Then $sKey = 'HKEY_CURRENT_USER\AppEvents\Schemes\Apps\Explorer'
    Local $sFile = StringReplace(RegRead($sKey &'\' & $sSoundName & '\.Default', ''), '%SystemRoot%', @WindowsDir)
    If $sFile = "" Then
        SoundPlay(StringReplace(RegRead($sKey &'\.Default\.Default', ''), '%SystemRoot%', @WindowsDir), $iWait)
    Else
        SoundPlay($sFile, $iWait)
    EndIf
EndFunc   ;==>_PlaySystemSound
